"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var redux_effects_promise_1 = require("redux-effects-promise");
var ts_smart_logger_1 = require("ts-smart-logger");
var R = require("ramda");
var di_1 = require("../di");
var util_1 = require("../util");
var storage_interface_1 = require("../storage/storage.interface");
var base_effects_1 = require("../store/effects/base.effects");
var application_action_builder_1 = require("../component/application/application-action.builder");
var dictionaries_action_builder_1 = require("../dictionary/dictionaries-action.builder");
var transport_action_builder_1 = require("../transport/transport-action.builder");
var notification_action_builder_1 = require("../notification/notification-action.builder");
var user_action_builder_1 = require("../user/user-action.builder");
var router_action_builder_1 = require("../router/router-action.builder");
var permissions_action_builder_1 = require("../permissions/permissions-action.builder");
var fetch_json_transport_factory_1 = require("../transport/fetch-json-transport.factory");
var UniversalApplicationEffects = /** @class */ (function (_super) {
    __extends(UniversalApplicationEffects, _super);
    function UniversalApplicationEffects() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UniversalApplicationEffects_1 = UniversalApplicationEffects;
    /**
     * @stable - 25.04.2018
     * @returns {Promise<IEffectsAction[]> | IEffectsAction[]}
     */
    UniversalApplicationEffects.prototype.$onInit = function () {
        return __awaiter(this, void 0, void 0, function () {
            var token, actions, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.settings.authorization.isAuthorizationNeeded === false) {
                            return [2 /*return*/, [
                                    application_action_builder_1.ApplicationActionBuilder.buildAuthorizedAction(),
                                    application_action_builder_1.ApplicationActionBuilder.buildAfterInitAction()
                                ]];
                        }
                        return [4 /*yield*/, this.notVersionedPersistentStorage.get(storage_interface_1.APPLICATION_TOKEN_KEY)];
                    case 1:
                        token = _a.sent();
                        actions = [];
                        if (token) {
                            actions.push(application_action_builder_1.ApplicationActionBuilder.buildAuthorizedAction({ token: token }));
                            actions.push(transport_action_builder_1.TransportActionBuilder.buildUpdateTokenAction({ token: token }));
                        }
                        result = actions.concat(application_action_builder_1.ApplicationActionBuilder.buildAfterInitAction());
                        UniversalApplicationEffects_1.logger.debug(function () {
                            return "[$UniversalApplicationEffects][$onInit] The actions are: " + JSON.stringify(result);
                        });
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * @stable [02.09.2018]
     * @returns {IEffectsAction}
     */
    UniversalApplicationEffects.prototype.$onAfterInit = function (_, state) {
        return __awaiter(this, void 0, void 0, function () {
            var isApplicationAuthorized, result, metaFilesJsonUrl, data, e_1, localAppUuid, remoteAppMetaInfo, remoteAppUuid;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        isApplicationAuthorized = state.application.authorized;
                        result = [
                            isApplicationAuthorized
                                ? application_action_builder_1.ApplicationActionBuilder.buildPrepareAction()
                                : application_action_builder_1.ApplicationActionBuilder.buildReadyAction()
                        ];
                        metaFilesJsonUrl = this.settings.metaFilesJsonUrl;
                        if (!(!R.isNil(metaFilesJsonUrl) && !R.isEmpty(metaFilesJsonUrl))) return [3 /*break*/, 5];
                        data = void 0;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, Promise.all([
                                this.notVersionedSessionStorage.get(storage_interface_1.APPLICATION_UUID_KEY),
                                this.fetchJsonTransportFactory.request({ url: metaFilesJsonUrl })
                            ])];
                    case 2:
                        data = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        UniversalApplicationEffects_1.logger.error('[$UniversalApplicationEffects][$onAfterInit] Error:', e_1);
                        return [3 /*break*/, 4];
                    case 4:
                        if (util_1.isArrayNotEmpty(data)) {
                            localAppUuid = data[0];
                            remoteAppMetaInfo = data[1];
                            remoteAppUuid = remoteAppMetaInfo.result.uuid;
                            if (!R.isNil(remoteAppUuid) && !R.isEmpty(remoteAppUuid)) {
                                this.notVersionedSessionStorage.set(storage_interface_1.APPLICATION_UUID_KEY, remoteAppUuid);
                                if (!R.isNil(localAppUuid)
                                    && !R.isEmpty(localAppUuid)
                                    && !R.equals(localAppUuid, remoteAppUuid)) {
                                    if (isApplicationAuthorized) {
                                        // After F5 we desire to get a previous saves hash, but it is empty. This means a team had released
                                        // a new version. To exclude the inconsistent state of App - redirect to initial path
                                        UniversalApplicationEffects_1.logger.debug('[$UniversalApplicationEffects][$onAfterInit] Need to redirect to the initial path because of a new release.');
                                        result.push(router_action_builder_1.RouterActionBuilder.buildRewriteAction(this.routes.home));
                                        result.push(notification_action_builder_1.NotificationActionBuilder.buildInfoAction(this.settings.messages.newAppVersionMessageHasBeenDeployed));
                                    }
                                }
                            }
                        }
                        _a.label = 5;
                    case 5:
                        UniversalApplicationEffects_1.logger.debug(function () {
                            return "[$UniversalApplicationEffects][$onAfterInit] The result is: " + JSON.stringify(result);
                        });
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * @stable - 25.04.2018
     * @returns {Promise<AnyT> | IEffectsAction[] | IEffectsAction}
     */
    UniversalApplicationEffects.prototype.$onPrepare = function () {
        return application_action_builder_1.ApplicationActionBuilder.buildReadyAction();
    };
    /**
     * @stable - 25.04.2018
     * @returns {Promise<AnyT> | IEffectsAction[] | IEffectsAction}
     */
    UniversalApplicationEffects.prototype.$onPrepareDone = function (action, state) {
        return application_action_builder_1.ApplicationActionBuilder.buildReadyAction();
    };
    /**
     * @stable [05.02.2019]
     * @param {IEffectsAction} action
     * @returns {IEffectsAction}
     */
    UniversalApplicationEffects.prototype.$onPrepareError = function (action) {
        return util_1.orNull(this.responseAccessor.isAuthError(action.error), function () { return (
        /**
         * We should show the login page instead of error page, therefore we clear an auth error before
         * page rendering.
         */
        application_action_builder_1.ApplicationActionBuilder.buildReadyAction()); });
    };
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[]}
     */
    UniversalApplicationEffects.prototype.$onAfterLogin = function () {
        return [
            application_action_builder_1.ApplicationActionBuilder.buildNotReadyAction(),
            application_action_builder_1.ApplicationActionBuilder.buildAuthorizedAction(),
            application_action_builder_1.ApplicationActionBuilder.buildPrepareAction(),
            router_action_builder_1.RouterActionBuilder.buildNavigateAction(this.routes.home)
        ];
    };
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[]}
     */
    UniversalApplicationEffects.prototype.$onLogout = function () {
        return [
            permissions_action_builder_1.PermissionsActionBuilder.buildDestroyAction(),
            user_action_builder_1.UserActionBuilder.buildDestroyAction(),
            dictionaries_action_builder_1.DictionariesActionBuilder.buildDestroyAction(),
            application_action_builder_1.ApplicationActionBuilder.buildUnauthorizedAction(),
            application_action_builder_1.ApplicationActionBuilder.buildAfterLogoutAction()
        ];
    };
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[] | Promise<IEffectsAction[]>}
     */
    UniversalApplicationEffects.prototype.$onAfterLogout = function () {
        return [
            notification_action_builder_1.NotificationActionBuilder.buildInfoAction(this.settings.messages.logoutNotificationMessage),
            transport_action_builder_1.TransportActionBuilder.buildDestroyTokenAction()
        ];
    };
    /**
     * @stable - 25.04.2018
     * @param {IEffectsAction} action
     * @param {IUniversalApplicationStoreEntity} state
     */
    UniversalApplicationEffects.prototype.$onAuthorized = function (action, state) {
        return __awaiter(this, void 0, void 0, function () {
            var payload, token;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        payload = action.data;
                        token = payload && payload.token || state.transport.token;
                        return [4 /*yield*/, this.notVersionedPersistentStorage.set(storage_interface_1.APPLICATION_TOKEN_KEY, token)];
                    case 1:
                        _a.sent();
                        UniversalApplicationEffects_1.logger.debug(function () {
                            return "[$UniversalApplicationEffects][$onAuthorized] The storage token has been saved: " + token + ".";
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable - 25.04.2018
     */
    UniversalApplicationEffects.prototype.$onUnauthorized = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.notVersionedPersistentStorage.remove(storage_interface_1.APPLICATION_TOKEN_KEY)];
                    case 1:
                        _a.sent();
                        UniversalApplicationEffects_1.logger.debug(function () {
                            return "[$UniversalApplicationEffects][$onUnauthorized] The storage token has been destroyed.";
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    var UniversalApplicationEffects_1;
    UniversalApplicationEffects.logger = ts_smart_logger_1.LoggerFactory.makeLogger('UniversalApplicationEffects');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Routes),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "routes", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "settings", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.NotVersionedPersistentStorage),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "notVersionedPersistentStorage", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.NotVersionedSessionStorage),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "notVersionedSessionStorage", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.TransportResponseAccessor),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "responseAccessor", void 0);
    __decorate([
        di_1.lazyInject(fetch_json_transport_factory_1.FetchJsonTransportFactory),
        __metadata("design:type", Object)
    ], UniversalApplicationEffects.prototype, "fetchJsonTransportFactory", void 0);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildInitActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onInit", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildAfterInitActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onAfterInit", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildPrepareActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Object)
    ], UniversalApplicationEffects.prototype, "$onPrepare", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildPrepareDoneActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Object)
    ], UniversalApplicationEffects.prototype, "$onPrepareDone", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildPrepareErrorActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Object)
    ], UniversalApplicationEffects.prototype, "$onPrepareError", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildAfterLoginActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Array)
    ], UniversalApplicationEffects.prototype, "$onAfterLogin", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildLogoutActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Array)
    ], UniversalApplicationEffects.prototype, "$onLogout", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildAfterLogoutActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Object)
    ], UniversalApplicationEffects.prototype, "$onAfterLogout", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildAuthorizedActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onAuthorized", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(application_action_builder_1.ApplicationActionBuilder.buildUnauthorizedActionType()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], UniversalApplicationEffects.prototype, "$onUnauthorized", null);
    UniversalApplicationEffects = UniversalApplicationEffects_1 = __decorate([
        inversify_1.injectable()
    ], UniversalApplicationEffects);
    return UniversalApplicationEffects;
}(base_effects_1.BaseEffects));
exports.UniversalApplicationEffects = UniversalApplicationEffects;
//# sourceMappingURL=universal-application.effects.js.map