"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var JsBarcode = require("jsbarcode");
var barcode_interface_1 = require("./barcode.interface");
/**
 * @stable [12.04.2019]
 * @param {string} barcode
 * @param {BarcodeFormatEnum[]} formats
 * @returns {BarcodeFormatEnum[]}
 */
exports.getBarcodeApplicableFormats = function (barcode, formats) {
    if (formats === void 0) { formats = barcode_interface_1.BARCODE_APPLICABLE_FORMATS; }
    return formats
        .map(function (format) {
        var value;
        JsBarcode({}, barcode, {
            format: format,
            valid: function (valid) {
                if (valid) {
                    value = format;
                }
            },
        });
        return value;
    })
        .filter(function (format) { return !!format; });
};
//# sourceMappingURL=barcode.support.js.map