/// <reference types="react" />
import { BaseComponent } from '../base';
import { IUniversalDialog, IDialogProps, IUniversalDialogProps } from './dialog.interface';
export declare class Dialog<TProps extends IDialogProps = IDialogProps, TState = {}> extends BaseComponent<TProps, TState> implements IUniversalDialog<TProps, TState> {
    static readonly defaultProps: IUniversalDialogProps;
    /**
     * @stable [04.10.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [03.08.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [17.05.2018]
     */
    activate(callback?: () => void): void;
    /**
     * @stable [17.05.2018]
     */
    onAccept(): void;
    /**
     * @stable [17.05.2018]
     */
    onClose(): void;
    /**
     * @stable [17.05.2018]
     * @returns {boolean}
     */
    readonly acceptable: boolean;
    /**
     * @stable [17.05.2018]
     * @returns {boolean}
     */
    readonly closable: boolean;
    /**
     * @stable [05.08.2018]
     * @returns {string}
     */
    protected getDialogClassName(): string;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    protected isCloseButtonDisabled(): boolean;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    protected isAcceptButtonDisabled(): boolean;
    /**
     * @stable [04.08.2018]
     * @returns {boolean}
     */
    protected isDialogVisible(): boolean;
    /**
     * @stable [24.03.2019]
     * @returns {JSX.Element}
     */
    private readonly dialogBodyElement;
    /**
     * @stable [24.03.2019]
     * @returns {JSX.Element}
     */
    private readonly dialogBodyContentElement;
    /**
     * @stable [24.03.2019]
     * @returns {JSX.Element}
     */
    private readonly footerElement;
}
