"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var chip_1 = require("../../chip");
var util_1 = require("../../../util");
var multifield_1 = require("../multifield");
var ChipsField = /** @class */ (function (_super) {
    __extends(ChipsField, _super);
    function ChipsField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [01.06.2018]
     * @returns {JSX.Element}
     */
    ChipsField.prototype.getAttachmentElement = function () {
        var _this = this;
        return (React.createElement("div", { className: 'rac-field-chips-wrapper' }, R.sort(function (o1, o2) { return util_1.NAME_ASC_SORTER_FN(o1.name, o2.name); }, this.multiFieldPlugin.activeValue).map(function (item) {
            var id = util_1.coalesce(item.id, item.value, util_1.uuid());
            return (React.createElement(chip_1.Chip, { key: id, id: id, disabled: _this.isFieldInactive(), onClick: function () { return _this.onDelete(item); } }, _this.toDisplayLabel(item)));
        })));
    };
    /**
     * @stable [01.06.2018]
     * @param {INamedEntity} item
     * @returns {EntityIdT}
     */
    ChipsField.prototype.toDisplayLabel = function (item) {
        var id = item.id;
        var selectedOption = this.options.find(function (option0) { return option0.value === id; });
        return selectedOption
            ? this.t(selectedOption.label)
            : (item.name || id);
    };
    return ChipsField;
}(multifield_1.MultiField));
exports.ChipsField = ChipsField;
//# sourceMappingURL=chipsfield.component.js.map