/// <reference types="react" />
import { IBasicEvent } from '../../../react-definitions.interface';
import { DateTimeLikeTypeT } from '../../../converter';
import { IDateFieldProps, IDateFieldState } from './datefield.interface';
import { BaseTextField } from '../textfield';
export declare class DateField<TProps extends IDateFieldProps = IDateFieldProps, TState extends IDateFieldState = IDateFieldState> extends BaseTextField<TProps, TState> {
    static defaultProps: IDateFieldProps;
    private readonly dialogRef;
    /**
     * @stable [07.01.2019]
     * @param {IDateFieldProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [07.01.2018]
     * @param {DateTimeLikeTypeT} currentRawValue
     */
    onChangeManually(currentRawValue: DateTimeLikeTypeT): void;
    protected getInputAttachmentElement(): JSX.Element;
    /**
     * @stable [07.01.2018]
     * @returns {Array<string | RegExp>}
     */
    protected getFieldMask(): Array<string | RegExp>;
    /**
     * @stable [07.01.2019]
     * @returns {string}
     */
    protected getFieldPattern(): string;
    /**
     * @stable [07.01.2019]
     * @returns {string}
     */
    protected getFieldFormat(): string;
    /**
     * @stable [07.01.2018]
     * @param {IBasicEvent} event
     */
    protected onClick(event: IBasicEvent): void;
    /**
     * @stable [07.01.2019]
     * @param {AnyT} value
     * @returns {string}
     */
    protected decorateValueBeforeDisplaying(value: DateTimeLikeTypeT): string;
    /**
     * @stable [02.05.2019]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [19.04.2019]
     * @param {number} value
     */
    private onChangeYear;
    /**
     * @stable [24.02.2019]
     * @param {Date} currentTime
     */
    private onAccept;
    /**
     * @stable [07.01.2019]
     * @returns {Date}
     */
    private readonly dialogDate;
    /**
     * @stable [24.02.2019]
     * @returns {Dialog}
     */
    private readonly dialog;
    /**
     * @stable [24.02.2019]
     * @returns {IDateTimeSettings}
     */
    private readonly dateTimeSettings;
    /**
     * @stable [07.01.2019]
     * @param {DateTimeLikeTypeT} value
     * @returns {string}
     */
    private formatDate;
    /**
     * @stable [24.02.2019]
     */
    private onCalendarClick;
}
