"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../../connector/vue-index");
var vue_index_2 = require("../multifield/vue-index");
var vue_base_filefield_component_1 = require("./vue-base-filefield.component");
var vue_single_file_field_interface_1 = require("./vue-single-file-field.interface");
var VueSingleFileField = /** @class */ (function (_super) {
    __extends(VueSingleFileField, _super);
    function VueSingleFileField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [25.11.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueSingleFileField.prototype.render = function (createElement) {
        return _super.prototype.render.call(this, createElement);
    };
    /**
     * @stable [28.11.2018]
     * @param newValue
     * @param {AnyT} context
     */
    VueSingleFileField.prototype.onChangeManually = function (newValue, context) {
        _super.prototype.onChangeManually.call(this, newValue, context);
    };
    /**
     * @stable [20.11.2018]
     * @returns {IEntity[]}
     */
    VueSingleFileField.prototype.getEntities = function () {
        if (!this.hasValue()) {
            return util_1.generateArray(1);
        }
        var value = this.getValue();
        if (util_1.isPrimitive(value)) {
            return [value];
        }
        var actualEntities = vue_index_2.toActualMultiItemEntities(value);
        return R.isNil(actualEntities) || actualEntities.length === 0 ? util_1.generateArray(1) : actualEntities;
    };
    /**
     * @stable [19.01.2019]
     * @param {File} file
     * @param {number} index
     * @returns {string}
     */
    VueSingleFileField.prototype.getViewerComponent = function (file, index) {
        var filesEntities = this.getEntities();
        return util_1.isArrayNotEmpty(filesEntities)
            ? this.toViewer(filesEntities[0].type || this.getFileFormat())
            : this.viewer;
    };
    /**
     * @stable [19.05.2019]
     * @returns {string}
     */
    VueSingleFileField.prototype.getFieldClassName = function () {
        return _super.prototype.getFieldClassName.call(this) + " vue-single-file-field";
    };
    VueSingleFileField = __decorate([
        vue_index_1.ComponentName(vue_single_file_field_interface_1.VUE_SINGLE_FILE_FIELD_NAME),
        vue_property_decorator_1.Component
    ], VueSingleFileField);
    return VueSingleFileField;
}(vue_base_filefield_component_1.VueBaseFileField));
//# sourceMappingURL=vue-single-file-field.component.js.map