"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../util");
var base_1 = require("../base");
var button_1 = require("../button");
var di_1 = require("../../di");
var field_1 = require("../field");
var form_interface_1 = require("./form.interface");
var form_support_1 = require("./form.support");
var layout_1 = require("../layout");
var api_1 = require("../../api");
var Form = /** @class */ (function (_super) {
    __extends(Form, _super);
    /**
     * @stable [29.05.2018]
     * @param {IFormProps} props
     */
    function Form(props) {
        var _this = _super.call(this, props) || this;
        _this.childrenMap = new Map();
        _this.onSubmit = _this.onSubmit.bind(_this);
        _this.onReset = _this.onReset.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        return _this;
    }
    Form.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var nodes = (util_1.cloneReactNodes(this, function (field) {
            var fieldProps = field.props;
            var predefinedOptions = _this.getFieldPredefinedOptions(field);
            return util_1.defValuesFilter(__assign({ value: _this.getFieldValue(field), originalValue: _this.getFieldOriginalValue(field), displayValue: _this.getFieldDisplayValue(field, predefinedOptions), readOnly: _this.isFieldReadOnly(field), disabled: _this.isFieldDisabled(field), changeable: _this.isFieldChangeable(field), changeForm: _this.onChange, 
                // Dynamic linked dictionary callbacks
                onEmptyDictionary: util_1.orUndef(fieldProps.bindDictionary || fieldProps.onEmptyDictionary, function () { return fieldProps.onEmptyDictionary || (function () { return _this.onEmptyDictionary(field); }); }), onDestroyDictionary: util_1.orUndef(fieldProps.bindDictionary || fieldProps.onDestroyDictionary, function () { return fieldProps.onDestroyDictionary || (function () { return _this.onDestroyDictionary(field); }); }), onLoadDictionary: util_1.orUndef(fieldProps.bindDictionary || fieldProps.onLoadDictionary, function () { return fieldProps.onLoadDictionary || (function (items0) { return _this.onLoadDictionary(field, items0); }); }) }, predefinedOptions, util_1.defValuesFilter({
                label: fieldProps.label,
                type: fieldProps.type,
                placeholder: fieldProps.placeholder,
                prefixLabel: fieldProps.prefixLabel,
            })));
        }, function (child) { return field_1.Field.isPrototypeOf(child.type); }, this.childrenMap, function (child) { return child.props.rendered; }));
        return (React.createElement("form", { ref: 'self', autoComplete: 'off', onReset: this.onReset, onSubmit: this.onSubmit, className: this.getFormClassName() },
            props.compact
                ? nodes
                : (React.createElement("div", { className: 'rac-form-body-wrapper' },
                    React.createElement("div", { className: 'rac-form-body' }, nodes))),
            this.formActionsWrapperElement));
    };
    /**
     * @stable [12.09.2018]
     */
    Form.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        if (this.props.validateOnMount) {
            this.propsOnValid();
        }
    };
    // TODO deprecated
    Form.prototype.componentWillUpdate = function () {
        this.childrenMap.clear();
    };
    Form.prototype.componentWillUnmount = function () {
        _super.prototype.componentWillUnmount.call(this);
        this.childrenMap.clear();
    };
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    Form.prototype.isFormValid = function () {
        return form_support_1.isFormValid(this.props);
    };
    /**
     * @stable - 11.04.2018
     * @param {IApiEntity} apiEntity
     */
    Form.prototype.submit = function (apiEntity) {
        var props = this.props;
        if (props.onSubmit) {
            props.onSubmit(apiEntity);
        }
    };
    Object.defineProperty(Form.prototype, "apiEntity", {
        /**
         * @stable - 11.04.2018
         * @returns {IApiEntity}
         */
        get: function () {
            return api_1.apiEntityFactory(this.changes, this.entity, this.originalEntity);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [25.02.2019]
     * @returns {string}
     */
    Form.prototype.getFormClassName = function () {
        var props = this.props;
        return util_1.toClassName('rac-form', 'rac-flex', 'rac-flex-column', 'rac-flex-no-shrink', props.full !== false && 'rac-flex-full', props.className);
    };
    Form.prototype.onChange = function (name, value, validationGroup) {
        if (this.props.onChange) {
            this.props.onChange({ name: name, value: value });
        }
        this.resetGroupFieldsErrors(name, validationGroup);
        this.propsOnValid();
    };
    /**
     * @stable [04.08.2018]
     * @param {IField} field
     */
    Form.prototype.onEmptyDictionary = function (field) {
        var props = this.props;
        if (props.onEmptyDictionary) {
            props.onEmptyDictionary(field.props.bindDictionary, this.apiEntity);
        }
    };
    // TODO
    Form.prototype.onDestroyDictionary = function (field) {
        var props = this.props;
        if (props.onDestroyDictionary && field.props.keepDictionary !== true) {
            // TODO props.onDestroyDictionary(field.props.bindDictionary);
        }
    };
    Form.prototype.onLoadDictionary = function (field, items) {
        var props = this.props;
        if (props.onLoadDictionary) {
            props.onLoadDictionary(items, field.props.bindDictionary);
        }
    };
    Form.prototype.propsOnValid = function () {
        if (this.props.onValid) {
            this.props.onValid(this.refs.self.checkValidity());
        }
    };
    /**
     * @stable - 11.04.2018
     * @param {BasicEventT} event
     */
    Form.prototype.onSubmit = function (event) {
        this.stopEvent(event);
        var props = this.props;
        var apiEntity = this.apiEntity;
        if (props.onBeforeSubmit) {
            if (props.onBeforeSubmit(apiEntity) !== false) {
                this.submit(apiEntity);
            }
        }
        else {
            this.submit(apiEntity);
        }
    };
    Form.prototype.onReset = function (event) {
        this.stopEvent(event);
        if (this.props.onReset) {
            this.props.onReset();
        }
    };
    Form.prototype.resetGroupFieldsErrors = function (name, validationGroup) {
        var _this = this;
        if (!validationGroup) {
            return;
        }
        this.childrenMap.forEach(function (uuidRef, child) {
            var childProps = child.props;
            var groupName = childProps.validationGroup;
            var fieldName = childProps.name;
            if (groupName === validationGroup && fieldName !== name) {
                var refObject = util_1.isString(uuidRef) ? null : uuidRef;
                var otherFieldInstanceAtTheSameGroup = refObject && refObject.current || _this.refs[uuidRef];
                if (otherFieldInstanceAtTheSameGroup) {
                    otherFieldInstanceAtTheSameGroup.resetError();
                }
                else {
                    Form.logger.warn("[$Form] The ref is not defined to the field with " + fieldName + " name.");
                }
            }
        });
    };
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    Form.prototype.isFormDirty = function () {
        return form_support_1.isFormDirty(this.props);
    };
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    Form.prototype.isFormSubmittable = function () {
        return form_support_1.isFormSubmittable(this.props);
    };
    /**
     * @stable [15.02.2019]
     * @returns {boolean}
     */
    Form.prototype.isFormResettable = function () {
        return form_support_1.isFormResettable(this.props);
    };
    /**
     * @stable [25.02.2019]
     * @returns {boolean}
     */
    Form.prototype.isFormOfNewEntity = function () {
        return form_support_1.isFormOfNewEntity(this.props);
    };
    /**
     * @stable [25.02.2019]
     * @returns {boolean}
     */
    Form.prototype.isFormBusy = function () {
        return form_support_1.isFormBusy(this.props);
    };
    /**
     * @stable - 11.04.2018
     * @param {IField} field
     * @returns {boolean}
     */
    Form.prototype.isFieldReadOnly = function (field) {
        return form_support_1.isFormFieldReadOnly(this.props, field.props);
    };
    /**
     * @stable - 11.04.2018
     * @param {IField} field
     * @returns {boolean}
     */
    Form.prototype.isFieldDisabled = function (field) {
        return form_support_1.isFormFieldDisabled(this.props, field.props);
    };
    /**
     * @stable [16.11.2018]
     * @param {IField} field
     * @returns {boolean}
     */
    Form.prototype.isFieldChangeable = function (field) {
        return form_support_1.isFormFieldChangeable(this.props, field.props);
    };
    Form.prototype.getFieldValue = function (field) {
        var fieldProps = field.props;
        return util_1.isUndef(fieldProps.value) && fieldProps.name
            ? Reflect.get(this.entity || this.changes, fieldProps.name)
            : fieldProps.value;
    };
    Form.prototype.getFieldOriginalValue = function (field) {
        var originalEntity = this.originalEntity;
        var fieldProps = field.props;
        return util_1.orUndef(fieldProps.name && originalEntity, function () { return Reflect.get(originalEntity, fieldProps.name); });
    };
    Form.prototype.getFieldDisplayValue = function (field, fieldConfiguration) {
        var fieldProps = field.props;
        var fieldDisplayName = fieldProps.displayName || (fieldConfiguration ? fieldConfiguration.displayName : null);
        return util_1.isUndef(fieldProps.displayValue) && fieldDisplayName
            ? Reflect.get(this.entity || this.changes, fieldDisplayName)
            : fieldProps.displayValue;
    };
    Form.prototype.getFieldPredefinedOptions = function (field) {
        var fieldOptionsOrLabel = this.fieldsOptions[field.props.name];
        var fieldOptions;
        if (util_1.isString(fieldOptionsOrLabel)) {
            // typings !
            fieldOptions = { label: fieldOptionsOrLabel };
        }
        else {
            fieldOptions = fieldOptionsOrLabel;
        }
        return fieldOptions;
    };
    Object.defineProperty(Form.prototype, "entity", {
        /**
         * @stable - 01.04.2018
         * @returns {IEntity}
         */
        get: function () {
            return this.props.entity;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Form.prototype, "originalEntity", {
        /**
         * @stable [10.06.2018]
         * @returns {IEntity}
         */
        get: function () {
            return this.props.originalEntity;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Form.prototype, "changes", {
        /**
         * @stable - 01.04.2018
         * @returns {IEntity}
         */
        get: function () {
            return this.form.changes;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Form.prototype, "form", {
        /**
         * @stable - 01.04.2018
         * @returns {IEntity}
         */
        get: function () {
            return this.props.form;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Form.prototype, "formActionsWrapperElement", {
        /**
         * @stable [25.02.2019]
         * @returns {JSX.Element}
         */
        get: function () {
            var _this = this;
            var props = this.props;
            return util_1.ifNotFalseThanValue(props.actionsRendered, function () { return (React.createElement(layout_1.FlexLayout, { full: false, row: true, justifyContentCenter: true, className: 'rac-form-actions' }, _this.formActionsElement)); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Form.prototype, "formActionsElement", {
        /**
         * @stable [25.02.2019]
         * @returns {JSX.Element}
         */
        get: function () {
            var _this = this;
            var props = this.props;
            var messages = this.settings.messages;
            var actions = util_1.notNilValuesArrayFilter(util_1.orNull(props.resetActionRendered, function () { return (__assign({ type: 'reset', icon: props.resetIcon || 'close', disabled: !_this.isFormResettable(), text: props.resetText || messages.reset }, props.buttonConfiguration, props.resetActionConfiguration, { onClick: null })); }), __assign({ type: 'submit', icon: this.isFormValid() ? (props.actionIcon || 'ok-filled') : 'error_outline', raised: true, disabled: !this.isFormSubmittable(), progress: this.isFormBusy(), error: !R.isNil(this.form.error), text: props.actionText || (this.isFormOfNewEntity() ? messages.create : messages.save) }, props.buttonConfiguration, props.submitActionConfiguration, { onClick: null }));
            return (React.createElement(React.Fragment, null, (util_1.isFn(props.actionsProvider) ? props.actionsProvider(actions) : actions)
                .map(function (action, index) { return (React.createElement(button_1.Button, __assign({ key: "form-action-" + (action.text || index) }, action, { onClick: util_1.orNull(action.onClick !== null, function () { return function () { return action.onClick(_this.apiEntity); }; }) }))); })));
        },
        enumerable: true,
        configurable: true
    });
    Form.defaultProps = {
        form: form_interface_1.INITIAL_APPLICATION_FORM_STATE,
        validateOnMount: true,
    };
    Form.logger = ts_smart_logger_1.LoggerFactory.makeLogger('Form');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.FieldsOptions),
        __metadata("design:type", Object)
    ], Form.prototype, "fieldsOptions", void 0);
    return Form;
}(base_1.BaseComponent));
exports.Form = Form;
//# sourceMappingURL=form.component.js.map