"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_1 = require("../../base");
var util_1 = require("../../../util");
var BaseGridColumn = /** @class */ (function (_super) {
    __extends(BaseGridColumn, _super);
    function BaseGridColumn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [10.09.2018]
     * @param {TProps} style
     * @returns {React.CSSProperties}
     */
    BaseGridColumn.prototype.getStyle = function (style) {
        var props = this.props;
        return util_1.defValuesFilter({
            textAlign: util_1.nvl(style && style.align, props.align),
            width: util_1.nvl(style && style.width, props.width),
        });
    };
    /**
     * @stable [15.09.2018]
     * @param {string} classNames
     * @returns {string}
     */
    BaseGridColumn.prototype.getClassName = function () {
        var classNames = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            classNames[_i] = arguments[_i];
        }
        var props = this.props;
        return util_1.toClassName.apply(void 0, ['rac-grid-column',
            util_1.ifNotNilThanValue(props.index, function () { return "rac-grid-column-" + props.index; }),
            util_1.isOddNumber(props.index) ? 'rac-grid-column-odd' : '',
            props.align && "rac-grid-column-align-" + props.align,
            props.className].concat(classNames));
    };
    /**
     * @stable [10.09.2018]
     * @param {string} classNames
     * @returns {JSX.Element}
     */
    BaseGridColumn.prototype.getColumnContentElement = function () {
        var classNames = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            classNames[_i] = arguments[_i];
        }
        var props = this.props;
        return (React.createElement("div", { className: util_1.toClassName.apply(void 0, ['rac-grid-column-content'].concat(classNames)) }, props.children));
    };
    return BaseGridColumn;
}(base_1.BaseComponent));
exports.BaseGridColumn = BaseGridColumn;
//# sourceMappingURL=base-grid-column.component.js.map