/// <reference types="react" />
import { IGridProps } from '../../props-definitions.interface';
import { IEntity } from '../../definitions.interface';
import { BaseList } from '../list';
import { IGridState } from './grid.interface';
export declare class Grid extends BaseList<IGridProps, IGridState> {
    /**
     * @stable [07.06.2018]
     * @param {IGridProps} props
     */
    constructor(props: IGridProps);
    /**
     * @stable [09.09.2018]
     * @returns {JSX.Element}
     */
    protected getView(): JSX.Element;
    /**
     * @stable [07.06.2018]
     * @returns {IEntity[]}
     */
    protected filterAndSortOriginalDataSourceUsingLocalFiltersAndSorters(): IEntity[];
    private onSettingsClick;
    /**
     * @stable [12.08.2018]
     */
    private onPlusClick;
    /**
     * @stable - 05.04.2018
     * @param {ISortDirectionEntity} payload
     */
    private onSortingDirectionChange;
    /**
     * @stable [06.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    private onChangeRowField;
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    private onChangeGroupingRowField;
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    private onChangeHeaderField;
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    private onChangeFilterField;
    /**
     * @stable - 06.04.2018
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {React.ReactNode}
     */
    private getHeaderColumnContent;
    /**
     * @stable - 06.04.2018
     * @returns {JSX.Element}
     */
    private readonly headerElement;
    /**
     * @stable [07.06.2018]
     * @param {IEntity} entity
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @param {number} rowNum
     * @param {IEntity[]} groupedRows
     * @returns {React.ReactNode}
     */
    private getColumn;
    /**
     * @stable [07.06.2018]
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {React.ReactNode}
     */
    private getFilterColumn;
    /**
     * @stable - 05.04.2018
     * @param {IEntity} entity
     * @param {number} rowNum
     * @param {boolean} applyOddClassName
     * @param {IEntity[]} groupedRows
     * @returns {JSX.Element}
     */
    private getRow;
    /**
     * @stable - 05.04.2018
     * @returns {JSX.Element}
     */
    private readonly filterElement;
    /**
     * @stable [07.06.2018]
     * @param {string} name
     * @returns {AnyT}
     */
    private toFilterFieldValue;
    /**
     * @stable [07.06.2018]
     * @returns {IFieldProps}
     */
    private getDefaultFieldProps;
    /**
     * @stable [07.06.2018]
     * @param {IEntity} entity
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {string}
     */
    private toFieldName;
    /**
     * @stable [07.06.2018]
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {string}
     */
    private toFilterFieldName;
    /**
     * @stable - 06.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    private toHeaderFieldName;
    /**
     * @stable - 05.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    private toFilterColumnKey;
    /**
     * @stable - 05.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    private toHeaderColumnKey;
    /**
     * @stable - 06.04.2018
     * @param {string} fieldName
     * @returns {AnyT}
     */
    private toFieldValue;
    /**
     * @stable - 06.04.2018
     * @param {string} fieldName
     * @returns {AnyT}
     */
    private toCheckboxFieldValue;
    /**
     * @stable [07.06.2018]
     * @param {JSX.Element} renderEl
     * @returns {boolean}
     */
    private isElementField;
    /**
     * @stable [10.10.2018]
     * @returns {IGridColumnConfiguration[]}
     */
    private readonly columnsConfiguration;
    /**
     * @stable [04.07.2018]
     * @param {EntityIdT} groupedRowValue
     * @returns {string}
     */
    private toGroupedRowKey;
    /**
     * @stable [27.12.2018]
     * @returns {string}
     */
    private toTotalRowKey;
    /**
     * @stable [05.10.2018]
     * @param {EntityIdT} groupedRowValue
     * @param {number} columnNum
     * @returns {string}
     */
    private toGroupedColumnKey;
    /**
     * @stable [27.12.2018]
     * @param {number} columnNum
     * @returns {string}
     */
    private toTotalColumnKey;
    /**
     * @stable [06.09.2018]
     * @param {IEntity[]} dataSource
     * @returns {JSX.Element[]}
     */
    private getGroupedRows;
    /**
     * @stable [04.07.2018]
     * @param {EntityIdT} groupedRowValue
     * @param {IEntity[]} groupedRows
     * @returns {JSX.Element}
     */
    private getGroupingRow;
    /**
     * @stable [27.12.2018]
     * @returns {JSX.Element}
     */
    private readonly totalRowElement;
    /**
     * @stable [04.07.2018]
     * @param {IBasicEvent} event
     * @param {EntityIdT} groupedRowValue
     * @param {boolean} expanded
     */
    private onExpandGroup;
    /**
     * @stable [03.09.2018]
     * @param {EntityIdT} groupedRowValue
     * @returns {boolean}
     */
    private isGroupedRowExpanded;
    /**
     * @stable [07.03.2019]
     * @param {IEntity} entity
     * @returns {AnyT}
     */
    private extractGroupedValue;
}
