"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var entities_definitions_interface_1 = require("../../../entities-definitions.interface");
var util_1 = require("../../../util");
var base_column_1 = require("../base-column");
var layout_1 = require("../../layout");
var GridHeaderColumn = /** @class */ (function (_super) {
    __extends(GridHeaderColumn, _super);
    /**
     * @stable [12.02.2019]
     * @param {IGridHeaderColumnProps} props
     */
    function GridHeaderColumn(props) {
        var _this = _super.call(this, props) || this;
        _this.onAscSortDirectionClick = _this.onAscSortDirectionClick.bind(_this);
        _this.onDescSortDirectionClick = _this.onDescSortDirectionClick.bind(_this);
        return _this;
    }
    /**
     * @stable [05.04.2018]
     * @returns {JSX.Element}
     */
    GridHeaderColumn.prototype.render = function () {
        var _this = this;
        var props = this.props;
        return util_1.orNull(props.headerRendered !== false, function () { return (React.createElement("th", { style: _this.getStyle({ width: props.headerWidth }), colSpan: util_1.nvl(props.headerColSpan, props.colSpan), className: _this.getClassName(props.useSorting && 'rac-grid-sorted-column', 'rac-no-user-select', props.headerClassName) },
            React.createElement(layout_1.FlexLayout, { row: true, alignItemsCenter: true, justifyContentCenter: true },
                _this.getColumnContentElement(),
                util_1.orNull(props.useSorting, function () { return (React.createElement(React.Fragment, null,
                    _this.uiFactory.makeIcon({
                        className: 'rac-grid-column-sorter-icon',
                        type: 'bottom',
                        onClick: _this.onDescSortDirectionClick,
                    }),
                    _this.uiFactory.makeIcon({
                        className: 'rac-grid-column-sorter-icon',
                        type: 'top',
                        onClick: _this.onAscSortDirectionClick,
                    }))); })))); });
    };
    /**
     * @stable [12.02.2019]
     * @param {IBasicEvent} event
     */
    GridHeaderColumn.prototype.onAscSortDirectionClick = function (event) {
        util_1.cancelEvent(event);
        var props = this.props;
        if (util_1.isFn(this.onDescSortDirectionClick)) {
            props.onSortingDirectionChange({
                name: props.name,
                direction: util_1.orNull(props.direction !== entities_definitions_interface_1.SortDirectionEnum.ASC, entities_definitions_interface_1.SortDirectionEnum.ASC),
            });
        }
    };
    /**
     * @stable [12.02.2019]
     * @param {IBasicEvent} event
     */
    GridHeaderColumn.prototype.onDescSortDirectionClick = function (event) {
        util_1.cancelEvent(event);
        var props = this.props;
        if (util_1.isFn(this.onDescSortDirectionClick)) {
            props.onSortingDirectionChange({
                name: props.name,
                direction: util_1.orNull(props.direction !== entities_definitions_interface_1.SortDirectionEnum.DESC, entities_definitions_interface_1.SortDirectionEnum.DESC),
            });
        }
    };
    return GridHeaderColumn;
}(base_column_1.BaseGridColumn));
exports.GridHeaderColumn = GridHeaderColumn;
//# sourceMappingURL=grid-header-column.component.js.map