"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var R = require("ramda");
var util_1 = require("../../util");
var vue_index_1 = require("../base/vue-index");
var vue_index_2 = require("../connector/vue-index");
var VueGrid = /** @class */ (function (_super) {
    __extends(VueGrid, _super);
    function VueGrid() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [23.10.2018]
     * @param {MouseEvent} event
     * @param row
     */
    VueGrid.prototype.onSelect = function (event, row) {
        this.$emit('onSelect', row);
    };
    /**
     * @stable [24.10.2018]
     * @param {IEntity} entity
     * @returns {string}
     */
    VueGrid.prototype.getRowClass = function (entity) {
        return util_1.toClassName(util_1.orEmpty(!R.isNil(this.rowClass), util_1.calc(this.rowClass, entity)), 'rac-grid-row', 'rac-grid-data-row', 'rac-grid-data-row-hovered', 'rac-grid-data-row-selectable', 'vue-grid-row');
    };
    /**
     * @stable [11.11.2018]
     * @param {IEntity} entity
     * @param {IVueGridColumnConfiguration} column
     * @returns {string | IVueGridColumnDynamicEntity}
     */
    VueGrid.prototype.getColumn = function (entity, column) {
        return column.renderer$
            ? column.renderer$(entity, column, entity[column.name$])
            : entity[column.name$];
    };
    /**
     * @stable [11.11.2018]
     * @param {IEntity} entity
     * @param {IVueGridColumnConfiguration} column
     * @returns {string}
     */
    VueGrid.prototype.getColumnDynamicComponent = function (entity, column) {
        var columnDynamicEntity = this.getColumn(entity, column);
        return util_1.orNull(columnDynamicEntity, function () { return columnDynamicEntity.component$; });
    };
    /**
     * @stable [11.11.2018]
     * @param {IEntity} entity
     * @param {IVueGridColumnConfiguration} column
     * @returns {string}
     */
    VueGrid.prototype.getColumnDynamicEvents = function (entity, column) {
        var columnDynamicEntity = this.getColumn(entity, column);
        var events$ = columnDynamicEntity.events$;
        var eventsScope = this.eventsScope;
        return R.isNil(eventsScope)
            ? events$
            : __assign({}, R.mergeAll(Object.keys(events$).map(function (eventCbName) {
                var _a;
                return (_a = {}, _a[eventCbName] = events$[eventCbName].bind(eventsScope), _a);
            })));
    };
    /**
     * @stable [11.11.2018]
     * @param {IEntity} entity
     * @param {IVueGridColumnConfiguration} column
     * @returns {IKeyValue}
     */
    VueGrid.prototype.getColumnDynamicBindings = function (entity, column) {
        var columnDynamicEntity = this.getColumn(entity, column);
        return columnDynamicEntity.bindings$;
    };
    /**
     * @stable [11.11.2018]
     * @param {IEntity} entity
     * @param {IVueGridColumnConfiguration} column
     * @returns {boolean}
     */
    VueGrid.prototype.isColumnDynamicEntity = function (entity, column) {
        return !util_1.isString(this.getColumn(entity, column));
    };
    /**
     * @stable [11.11.2018]
     * @param {IEntity} entity
     * @param {IVueGridColumnConfiguration} column
     * @returns {string}
     */
    VueGrid.prototype.getColumnStyle = function (entity, column) {
        return column.style$ || '';
    };
    VueGrid.prototype.isListBusy = function () {
        return this.list.progress;
    };
    Object.defineProperty(VueGrid.prototype, "isEmptyData", {
        get: function () {
            return !this.isListBusy() && this.listData.length === 0;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueGrid.prototype, "columns", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueGrid.prototype, "list", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueGrid.prototype, "filterQuery", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueGrid.prototype, "filter", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueGrid.prototype, "rowClass", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueGrid.prototype, "eventsScope", void 0);
    VueGrid = __decorate([
        vue_index_2.ComponentName('vue-grid'),
        vue_property_decorator_1.Component({
            template: "\n      <div class=\"rac-grid-wrapper\">\n        <table v-if=\"!isListBusy()\"\n               cellpadding=\"0\"\n               cellspacing=\"0\"\n               class=\"rac-grid vue-grid\">\n          <tbody class=\"rac-grid-body\">\n            <tr v-for=\"entity in listData\"\n                :class=\"getRowClass(entity)\"\n                v-on:click=\"onSelect($event, entity)\">\n              <td v-for=\"column in columns\"\n                  :style=\"getColumnStyle(entity, column)\"\n                  class=\"rac-grid-column\">\n                    <div v-if=\"!isColumnDynamicEntity(entity, column)\"\n                         v-html=\"getColumn(entity, column)\"\n                         class=\"rac-grid-column-content\"/>\n                    <div v-else\n                         class=\"rac-grid-column-content vue-grid-column-content\">\n                      <component v-if=\"getColumnDynamicComponent(entity, column)\"\n                                 :is=\"getColumnDynamicComponent(entity, column)\"\n                                 v-on=\"getColumnDynamicEvents(entity, column)\"\n                                 v-bind=\"getColumnDynamicBindings(entity, column)\"/>\n                    </div>\n              </td>\n            </tr>\n          </tbody>\n        </table>\n        <div v-if=\"isListBusy()\">\n          Please wait...\n        </div>\n        <div v-if=\"isEmptyData\">\n          No data\n        </div>\n      </div>\n    ",
            computed: {
                listData: {
                    get: function () {
                        var _this = this;
                        var data = this.list.data || [];
                        return !R.isNil(this.filter)
                            ? data.filter(function (item) { return _this.filter(item, _this.filterQuery); })
                            : (!R.isNil(this.filterQuery)
                                ? function (item) { return !_this.filterQuery || item.name.indexOf(_this.filterQuery) > -1; }
                                : data);
                    },
                },
            },
        })
    ], VueGrid);
    return VueGrid;
}(vue_index_1.VueBaseComponent));
//# sourceMappingURL=vue-grid.component.js.map