"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../../connector/vue-index");
var vue_index_2 = require("../../base/vue-index");
var vue_index_3 = require("../../tooltip/vue-index");
// TODO
var VueFlexLayout = /** @class */ (function (_super) {
    __extends(VueFlexLayout, _super);
    function VueFlexLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [27.05.2019]
     */
    VueFlexLayout.prototype.mounted = function () {
        if (util_1.isDef(this.tooltip)) {
            this.tooltipPlugin = new vue_index_3.GenericTooltipPlugin();
            this.tooltipPlugin.setTarget(this.getContentRef());
            this.tooltipPlugin.setTooltip(this.tooltip);
            this.tooltipPlugin.init();
        }
    };
    /**
     * @stable [27.05.2019]
     */
    VueFlexLayout.prototype.onTooltipUpdate = function () {
        this.tooltipPlugin.setTooltip(this.tooltip);
        this.tooltipPlugin.init();
    };
    /**
     * @stable [27.05.2019]
     */
    VueFlexLayout.prototype.beforeDestroy = function () {
        if (util_1.isDef(this.tooltipPlugin)) {
            this.tooltipPlugin.destroy();
            this.tooltipPlugin = null;
        }
    };
    /**
     * @stable [27.05.2019]
     * @param {VueCreateElementFactoryT} factory
     * @returns {VueNodeT}
     */
    VueFlexLayout.prototype.render = function (factory) {
        var nodeData = {
            ref: 'contentRef',
            class: this.getClassName(),
            style: this.styles,
            attrs: {
                title: this.title,
            },
        };
        return factory('div', nodeData, this.$slots.default);
    };
    VueFlexLayout.prototype.getClassName = function () {
        var props = this;
        return util_1.toClassName('rac-flex', /* @stable [19.05.2019] */ util_1.calc(props.className), /* @stable [19.05.2019] */ props.responsive /* @stable [19.05.2019] */
            ? 'rac-flex-responsive'
            : (props.row ? 'rac-flex-row' : 'rac-flex-column'), props.full !== false && 'rac-flex-full', /* @stable [19.05.2019] */ props.noShrink && 'rac-flex-no-shrink', /* @stable [19.05.2019] */ props.wrap && 'rac-flex-wrap', /* @stable [19.05.2019] */ props.fullSize && 'rac-full-size', props.separator && 'rac-flex-separator', props.alignItemsCenter && 'rac-flex-align-items-center', props.alignItemsEnd && 'rac-flex-align-items-end', props.justifyContentCenter && 'rac-flex-justify-content-center', props.justifyContentEnd && 'rac-flex-justify-content-end');
    };
    /**
     * @stable [27.05.2019]
     * @returns {HTMLElement}
     */
    VueFlexLayout.prototype.getContentRef = function () {
        return this.$refs.contentRef;
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueFlexLayout.prototype, "children", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "responsive", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "wrap", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "noShrink", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "row", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueFlexLayout.prototype, "tooltip", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "separator", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "alignItemsCenter", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "alignItemsEnd", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "justifyContentCenter", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "justifyContentEnd", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueFlexLayout.prototype, "fullSize", void 0);
    __decorate([
        vue_property_decorator_1.Watch('tooltip'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], VueFlexLayout.prototype, "onTooltipUpdate", null);
    VueFlexLayout = __decorate([
        vue_index_1.ComponentName('vue-flex-layout'),
        vue_property_decorator_1.Component
    ], VueFlexLayout);
    return VueFlexLayout;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-flex-layout.component.js.map