"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var cropperjs_1 = require("cropperjs");
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../../connector/vue-index");
var vue_viewer_interface_1 = require("../vue-viewer.interface");
var vue_entities_definitions_interface_1 = require("../../../vue-entities-definitions.interface");
var vue_index_2 = require("../picture/vue-index");
var vue_cropper_viewer_interface_1 = require("./vue-cropper-viewer.interface");
var VueCropperViewer = /** @class */ (function (_super) {
    __extends(VueCropperViewer, _super);
    function VueCropperViewer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.cropEmitterTask = new util_1.DelayedTask(_this.onCrop, 100);
        _this.scaleData = [1, -1];
        _this.horizontalScaleCursor = 0;
        _this.verticalScaleCursor = 0;
        return _this;
    }
    /**
     * @stable [29.11.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueCropperViewer.prototype.render = function (createElement) {
        return _super.prototype.render.call(this, createElement);
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onRemove = function () {
        var _this = this;
        this.onClosePopup();
        this.$nextTick(function () { return _super.prototype.onRemove.call(_this); });
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onOpenPopup = function () {
        _super.prototype.onOpenPopup.call(this);
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.beforeDestroy = function () {
        this.cropEmitterTask.stop();
        if (util_1.isDef(this.cropper)) {
            this.cropper.destroy();
            this.cropper = null;
        }
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onClosePopup = function () {
        _super.prototype.onClosePopup.call(this);
    };
    /**
     * @stable [21.01.2019]
     * @returns {string}
     */
    VueCropperViewer.prototype.getPopupHeaderTemplate = function () {
        return "\n        <vue-flex-layout :row=\"true\">\n            <vue-button @click=\"onApply\"\n                        icon=\"check\"/>\n            <vue-button @click=\"onRemove\"\n                        icon=\"trash\"\n                        className=\"vue-cropper-viewer-remove-action\"/>\n        </vue-flex-layout>\n    ";
    };
    /**
     * @stable [21.03.2019]
     * @returns {string}
     */
    VueCropperViewer.prototype.getPopupFooterTemplate = function () {
        return "\n        <vue-flex-layout :row=\"true\">\n            <vue-button @click=\"onZoomIn\"\n                        icon=\"zoom-in\"/>\n            <vue-button @click=\"onZoomOut\"\n                        icon=\"zoom-out\"/>\n            <vue-button @click=\"onRotateLeft\"\n                        icon=\"rotate-left\"/>\n            <vue-button @click=\"onRotateRight\"\n                        icon=\"rotate-right\"/>\n            <vue-button @click=\"onFlipHorizontal\"\n                        icon=\"flip-horizontal\"/>\n            <vue-button @click=\"onFlipVertical\"\n                        icon=\"flip-vertical\"/>\n        </vue-flex-layout>\n    ";
    };
    /**
     * @stable [29.11.2018]
     * @returns {IVueCropperPictureViewerTemplateMethodsEntity}
     */
    VueCropperViewer.prototype.getTemplateMethods = function () {
        return __assign({}, _super.prototype.getTemplateMethods.call(this), { onApply: this.onApply, onZoomIn: this.onZoomIn, onZoomOut: this.onZoomOut, onFlipHorizontal: this.onFlipHorizontal, onFlipVertical: this.onFlipVertical, onRotateLeft: this.onRotateLeft, onRotateRight: this.onRotateRight });
    };
    /**
     * @stable [21.01.2019]
     * @returns {string}
     */
    VueCropperViewer.prototype.getPopupClassName = function () {
        return util_1.toClassName(_super.prototype.getPopupClassName.call(this), 'vue-cropper-viewer-popup');
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onAfterOpenPopup = function () {
        var _this = this;
        _super.prototype.onAfterOpenPopup.call(this);
        this.cropper = new cropperjs_1.default(this.getSelf(), __assign({ crop: function () { return _this.cropEmitterTask.start(); } }, this.options));
    };
    /**
     * @stable [06.01.2019]
     * @returns {string}
     */
    VueCropperViewer.prototype.getClassName = function () {
        return util_1.toClassName('vue-picture-viewer vue-cropper-viewer', _super.prototype.getClassName.call(this));
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onApply = function () {
        var _this = this;
        this.getCroppedCanvasBlob(function (blob) {
            _this.onClosePopup();
            _this.$nextTick(function () { return _this.$emit(vue_viewer_interface_1.VUE_VIEWER_CHANGE_EVENT, blob); });
        });
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onCrop = function () {
        var _this = this;
        this.getCroppedCanvasBlob(function (blob) { return _this.$emit(vue_cropper_viewer_interface_1.VUE_CROPPER_VIEWER_CROP_EVENT, blob); });
    };
    /**
     * @stable [29.11.2018]
     * @param {(blob: Blob) => void} callback
     */
    VueCropperViewer.prototype.getCroppedCanvasBlob = function (callback) {
        this.cropper.getCroppedCanvas(this.croppedCanvasOptions).toBlob(callback);
    };
    /**
     * @stable [21.03.2019]
     */
    VueCropperViewer.prototype.onZoomIn = function () {
        this.cropper.zoom(0.1);
    };
    /**
     * @stable [21.03.2019]
     */
    VueCropperViewer.prototype.onZoomOut = function () {
        this.cropper.zoom(-0.1);
    };
    /**
     * @stable [21.03.2019]
     */
    VueCropperViewer.prototype.onRotateLeft = function () {
        this.cropper.rotate(-90);
    };
    /**
     * @stable [21.03.2019]
     */
    VueCropperViewer.prototype.onRotateRight = function () {
        this.cropper.rotate(90);
    };
    /**
     * @stable [21.03.2019]
     */
    VueCropperViewer.prototype.onFlipHorizontal = function () {
        this.changeScale(true);
    };
    /**
     * @stable [21.03.2019]
     */
    VueCropperViewer.prototype.onFlipVertical = function () {
        this.changeScale(false);
    };
    /**
     * @stable [21.03.2019]
     * @param {boolean} horizontal
     */
    VueCropperViewer.prototype.changeScale = function (horizontal) {
        if (horizontal) {
            this.horizontalScaleCursor = this.horizontalScaleCursor === this.scaleData.length - 1 ? 0 : this.horizontalScaleCursor + 1;
        }
        else {
            this.verticalScaleCursor = this.verticalScaleCursor === this.scaleData.length - 1 ? 0 : this.verticalScaleCursor + 1;
        }
        var currentHorizontalScaleData = this.scaleData[this.horizontalScaleCursor];
        var currentVerticalScaleData = this.scaleData[this.verticalScaleCursor];
        this.cropper.scale(currentHorizontalScaleData, currentVerticalScaleData);
    };
    __decorate([
        vue_property_decorator_1.Prop({
            default: function () { return ({
                cropBoxResizable: false,
                aspectRatio: 568 / 426,
                minCropBoxWidth: 568,
            }); },
        }),
        __metadata("design:type", Object)
    ], VueCropperViewer.prototype, "options", void 0);
    __decorate([
        vue_property_decorator_1.Prop({
            default: function () { return ({
                maxWidth: 1024,
            }); },
        }),
        __metadata("design:type", Object)
    ], VueCropperViewer.prototype, "croppedCanvasOptions", void 0);
    VueCropperViewer = __decorate([
        vue_index_1.ComponentName(vue_cropper_viewer_interface_1.VUE_CROPPER_VIEWER_NAME),
        vue_property_decorator_1.Component(vue_entities_definitions_interface_1.vueDefaultComponentConfigFactory())
    ], VueCropperViewer);
    return VueCropperViewer;
}(vue_index_2.VueBasePictureViewer));
//# sourceMappingURL=vue-cropper-viewer.component.js.map