"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var dragscroll = require("dragscroll");
var vue_index_1 = require("../../base/vue-index");
var VueBasePreview = /** @class */ (function (_super) {
    __extends(VueBasePreview, _super);
    /**
     * @stable [24.02.2019]
     */
    function VueBasePreview() {
        var _this = _super.call(this) || this;
        _this.onScaleIncrease = _this.onScaleIncrease.bind(_this);
        _this.onScaleDecrease = _this.onScaleDecrease.bind(_this);
        return _this;
    }
    /**
     * @stable [30.01.2019]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueBasePreview.prototype.render = function (createElement) {
        var options = {
            methods: this.getTemplateMethods(),
            template: "\n          <vue-flex-layout class=\"" + this.getClassName() + "\">\n              <vue-flex-layout class=\"vue-preview-content-wrapper dragscroll\">\n                    " + this.getPreviewTemplate() + "\n              </vue-flex-layout>\n              <div class=\"vue-viewer-scale-action\n                          vue-icon-zoom-plus\n                          vue-icon\n                          rac-no-user-select\"\n                          @click=\"onScaleIncrease\">\n                    &nbsp;\n              </div>\n              <div class=\"vue-viewer-scale-action\n                          vue-icon-zoom-minus\n                          vue-icon\n                          rac-no-user-select\"\n                          @click=\"onScaleDecrease\">\n                    &nbsp;\n              </div>\n          </vue-flex-layout>\n      ",
        };
        return createElement(options);
    };
    /**
     * @stable [14.11.2018]
     */
    VueBasePreview.prototype.mounted = function () {
        this.refresh();
    };
    /**
     * @stable [30.01.2019]
     */
    VueBasePreview.prototype.updated = function () {
        this.refresh();
    };
    /**
     * @stable [14.11.2018]
     */
    VueBasePreview.prototype.onScaleIncrease = function () {
        this.onChangeScale(this.scaleFactor);
    };
    /**
     * @stable [14.11.2018]
     */
    VueBasePreview.prototype.onScaleDecrease = function () {
        this.onChangeScale(-this.scaleFactor);
    };
    /**
     * @stable [30.01.2019]
     * @returns {TVuePreviewState}
     */
    VueBasePreview.prototype.getInitialData$ = function () {
        return { scale: 1 };
    };
    /**
     * @stable [24.02.2019]
     * @returns {string}
     */
    VueBasePreview.prototype.getClassName = function () {
        return 'vue-preview';
    };
    /**
     * @stable [30.01.2019]
     * @returns {TMethods}
     */
    VueBasePreview.prototype.getTemplateMethods = function () {
        return {
            onScaleIncrease: this.onScaleIncrease,
            onScaleDecrease: this.onScaleDecrease,
        };
    };
    /**
     * @stable [11.11.2018]
     * @param {MouseEvent} event
     */
    VueBasePreview.prototype.onClick = function (event) {
        this.$emit('click', event);
    };
    /**
     * @stable [14.11.2018]
     * @param {number} scale
     */
    VueBasePreview.prototype.onChangeScale = function (scale) {
        this.getData().scale += scale;
    };
    /**
     * @stable [30.01.2019]
     */
    VueBasePreview.prototype.refresh = function () {
        dragscroll.reset();
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueBasePreview.prototype, "src", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 1; } }),
        __metadata("design:type", Number)
    ], VueBasePreview.prototype, "scaleFactor", void 0);
    return VueBasePreview;
}(vue_index_1.VueBaseComponent));
exports.VueBasePreview = VueBasePreview;
//# sourceMappingURL=vue-base-preview.component.js.map