import { PhoneNumberFormat as PNF } from 'google-libphonenumber';
import { INumberConverter } from './number-converter.interface';
import { EntityIdT, StringNumberT } from '../../definitions.interface';
export declare class NumberConverter implements INumberConverter {
    private settings;
    private defaultFormatter;
    private phoneUtilInstance;
    /**
     * @stable [22.10.2018]
     */
    private defaultCurrencyFormatOptions;
    private currencyFormatter;
    /**
     * @stable [22.10.2018]
     */
    private defaultIntegerFormatOptions;
    private integerFormatter;
    /**
     * @stable [22.10.2018]
     */
    private defaultFractionalFormatOptions;
    private fractionalFormatter;
    /**
     * @stable [22.10.2018]
     */
    private defaultIntegerCurrencyFormatOptions;
    private integerCurrencyFormatter;
    /**
     * @stable [22.10.2018]
     */
    constructor();
    /**
     * @stable [28.09.2018]
     * @param {StringNumberT} value
     * @param {number} radix
     * @returns {StringNumberT}
     */
    integer(value: StringNumberT, radix?: number): StringNumberT;
    number(value: string | number, stringResult?: boolean): string | number;
    format(value: string | number, formatter?: {
        format(...args: any[]): string;
    }): string;
    integerCurrency(value: StringNumberT): string;
    /**
     * @stable [22.10.2018]
     * @param {StringNumberT} value
     * @returns {string}
     */
    integerFormat(value: StringNumberT): string;
    /**
     * @stable [22.10.2018]
     * @param {StringNumberT} value
     * @returns {string}
     */
    fractionalFormat(value: StringNumberT): string;
    currency(value: number | string, options?: Intl.NumberFormatOptions): string;
    /**
     * @stable [01.09.2018]
     * @param {EntityIdT} value
     * @returns {string}
     */
    id(value: EntityIdT): string;
    /**
     * @stable [01.09.2018]
     * @param {EntityIdT} value
     * @returns {string}
     */
    internalId(value: EntityIdT): string;
    phone(value: number | string, phoneNumberFormat?: PNF): string;
    /**
     * @stable [22.10.2018]
     * @returns {string}
     */
    private readonly uiLocale;
}
