"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var util_1 = require("../util");
var env_1 = require("../env");
var di_1 = require("../di");
var application_action_builder_1 = require("../component/application/application-action.builder");
var VueRouter = /** @class */ (function () {
    /**
     * @stable [23.10.2018]
     */
    function VueRouter() {
        var _this = this;
        var prevOnPopState = window.onpopstate;
        window.onpopstate = function () {
            if (util_1.isFn(prevOnPopState)) {
                prevOnPopState.call(window);
            }
            _this.dispatchPathAction(location.pathname);
        };
    }
    /**
     * @stable [23.10.2018]
     * @param path
     */
    VueRouter.prototype.push = function (path) {
        var fullPath = env_1.ENV.buildAppPath(path);
        history.pushState({}, fullPath, fullPath);
        this.dispatchPathAction(path);
    };
    VueRouter.prototype.replace = function (path) {
        var fullPath = env_1.ENV.buildAppPath(path);
        history.replaceState({}, fullPath, fullPath);
        this.dispatchPathAction(path);
    };
    VueRouter.prototype.go = function (delta) {
        history.go(delta);
    };
    /**
     * @stable [23.10.2018]
     */
    VueRouter.prototype.goBack = function () {
        this.go(-1);
    };
    /**
     * @stable [23.10.2018]
     * @param {string} data
     */
    VueRouter.prototype.dispatchPathAction = function (data) {
        this.store.dispatch({ type: application_action_builder_1.ApplicationActionBuilder.buildPathActionType(), data: data });
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Store),
        __metadata("design:type", Object)
    ], VueRouter.prototype, "store", void 0);
    VueRouter = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [])
    ], VueRouter);
    return VueRouter;
}());
exports.VueRouter = VueRouter;
//# sourceMappingURL=vue-router.service.js.map