"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var util_1 = require("../../util");
var di_1 = require("../../di");
var action_builder_1 = require("../../component/action.builder");
var router_action_builder_1 = require("../../router/router-action.builder");
var custom_action_builder_1 = require("../../action/custom/custom-action.builder");
var middleware_1 = require("../middleware");
function makeEditedListEffectsProxy(config) {
    var path = config.path, changesResolver = config.changesResolver, listSection = config.listSection, formSection = config.formSection, useLazyLoading = config.useLazyLoading;
    return function () {
        var Effects = /** @class */ (function () {
            function Effects() {
            }
            Effects_1 = Effects;
            Effects.prototype.$onEntityCreate = function (action, state) {
                return middleware_1.makeCreateEntityMiddleware({ action: action, state: state, path: path, formSection: formSection });
            };
            /**
             * @stable [29.06.2018]
             * @param {IEffectsAction} action
             * @param {TApplicationState} state
             * @returns {IEffectsAction[]}
             */
            Effects.prototype.$onEntitySelect = function (action, state) {
                return middleware_1.makeSelectEntityMiddleware({ action: action, state: state, path: path, useLazyLoading: useLazyLoading, formSection: formSection, listSection: listSection });
            };
            /**
             * @stable [29.06.2018]
             * @param {IEffectsAction} action
             * @param {TApplicationState} state
             * @returns {IEffectsAction[]}
             */
            Effects.prototype.$onEntityLazyLoadDone = function (action, state) {
                return middleware_1.makeSelectEntityMiddleware({ action: action, state: state, path: path, formSection: formSection, listSection: listSection });
            };
            Effects.prototype.$onEntityClone = function (_, state) {
                return [
                    action_builder_1.FormActionBuilder.buildChangesAction(formSection, util_1.excludeIdFieldFilter(changesResolver(state))),
                    action_builder_1.ListActionBuilder.buildDeselectAction(listSection),
                    router_action_builder_1.RouterActionBuilder.buildReplaceAction(path(null, state))
                ];
            };
            var Effects_1;
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ListActionBuilder.buildCreateActionType(listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onEntityCreate", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ListActionBuilder.buildSelectActionType(listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onEntitySelect", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ListActionBuilder.buildLazyLoadDoneActionType(listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onEntityLazyLoadDone", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(custom_action_builder_1.CustomActionBuilder.buildCustomCloneActionType(formSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onEntityClone", null);
            Effects = Effects_1 = __decorate([
                di_1.provideInSingleton(Effects_1)
            ], Effects);
            return Effects;
        }());
    };
}
exports.makeEditedListEffectsProxy = makeEditedListEffectsProxy;
//# sourceMappingURL=edited-list-effects.proxy.js.map