"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var di_1 = require("../../di");
var middleware_1 = require("../middleware");
var filter_form_dialog_action_builder_1 = require("../../component/dialog/filter-form-dialog/filter-form-dialog-action.builder");
/**
 * @stable [11.03.2019]
 */
function makeFilterFormDialogEffectsProxy(config) {
    var filterFormDialogClearMiddleware = middleware_1.makeFilterFormDialogClearMiddleware(config);
    var filterFormDialogResetMiddleware = middleware_1.makeFilterFormDialogResetMiddleware(config);
    var filterFormDialogAcceptMiddleware = middleware_1.makeFilterFormDialogAcceptMiddleware(config);
    return function () {
        var Effects = /** @class */ (function () {
            function Effects() {
            }
            Effects_1 = Effects;
            /**
             * @stable [11.03.2019]
             * @returns {IEffectsAction[]}
             */
            Effects.prototype.$onAccept = function () {
                return filterFormDialogAcceptMiddleware;
            };
            /**
             * @stable [11.03.2019]
             * @returns {IEffectsAction[]}
             */
            Effects.prototype.$onClear = function () {
                return filterFormDialogClearMiddleware;
            };
            /**
             * @stable [12.03.2019]
             * @returns {IEffectsAction[]}
             */
            Effects.prototype.$onReset = function () {
                return filterFormDialogResetMiddleware;
            };
            var Effects_1;
            __decorate([
                redux_effects_promise_1.EffectsService.effects(filter_form_dialog_action_builder_1.FilterFormDialogActionBuilder.buildAcceptActionType(config.formSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Object)
            ], Effects.prototype, "$onAccept", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(filter_form_dialog_action_builder_1.FilterFormDialogActionBuilder.buildClearActionType(config.formSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onClear", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(filter_form_dialog_action_builder_1.FilterFormDialogActionBuilder.buildResetActionType(config.formSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Object)
            ], Effects.prototype, "$onReset", null);
            Effects = Effects_1 = __decorate([
                di_1.provideInSingleton(Effects_1)
            ], Effects);
            return Effects;
        }());
    };
}
exports.makeFilterFormDialogEffectsProxy = makeFilterFormDialogEffectsProxy;
//# sourceMappingURL=filer-form-dialog-effects.proxy.js.map