"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var list_action_builder_1 = require("../../component/list/list-action.builder");
var form_action_builder_1 = require("../../component/form/form-action.builder");
/**
 * @stable [22.03.2019]
 * @param {IDestroyedComponentMiddlewareConfig} config
 * @returns {IEffectsAction[]}
 */
exports.makeDestroyedComponentMiddleware = function (config) {
    return (config.formsSections || [])
        .map(function (formSection) { return form_action_builder_1.FormActionBuilder.buildDestroyAction(formSection); }).concat((config.listsSections || [])
        .map(function (listSection) { return list_action_builder_1.ListActionBuilder.buildDestroyAction(listSection); }));
};
//# sourceMappingURL=destroyed-component.middleware.js.map