"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var nvl_1 = require("./nvl");
var cond_1 = require("./cond");
/**
 * @stable [16.12.2018]
 * @param {number} length
 * @returns {AnyT[]}
 */
exports.generateArray = function (length) { return Array.apply(null, { length: length }); };
/**
 * @stable [19.11.2018]
 * @param {number[]} array
 * @returns {number}
 */
exports.arrayMinValue = function (array) { return R.reduce(R.min, Infinity, array); };
/**
 * @stable [22.11.2018]
 * @param {number[]} array
 * @returns {number}
 */
exports.arrayNextMinNegativeValue = function (array) { return Math.min(Number(exports.arrayMinValue(array)), 0) - 1; };
/**
 * @stable [19.12.2018]
 * @param {TValue[]} array
 * @returns {boolean}
 */
exports.isArrayNotEmpty = function (array) { return Array.isArray(array) && !R.isEmpty(array); };
/**
 * @stable [28.01.2019]
 * @param {TValue[]} array
 * @param {number} limit
 * @returns {TValue[]}
 */
exports.subArray = function (array, limit) {
    return cond_1.ifNotNilThanValue(array, function () { return array.slice(0, Math.min(array.length, nvl_1.nvl(limit, array.length))); });
};
//# sourceMappingURL=array.js.map