"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @stable [05.05.2019]
 * @param {number} num
 * @param {number} precision
 * @returns {number}
 */
exports.roundByPrecision = function (num, precision) {
    if (precision === void 0) { precision = 2; }
    return Math.round(num * (10 * precision)) / (10 * precision);
};
/**
 * @stable [05.05.2019]
 * @param {number} num
 * @param {number} divider
 * @returns {number}
 */
exports.roundDownByDivider = function (num, divider) {
    return Math.floor(num - num % divider);
};
/**
 * @stable [13.05.2019]
 * @param {number} num
 * @param {number} precision
 * @returns {number}
 */
exports.invertCurrency = function (num, precision) {
    if (precision === void 0) { precision = 2; }
    var result = exports.roundByPrecision(num, precision);
    return result === 0 ? result : result * -1;
};
//# sourceMappingURL=number.js.map