"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @stable [09.04.2019]
 * @param {StringNumberT} value1
 * @param {StringNumberT} value2
 * @returns {number}
 * @constructor
 */
exports.NAME_ASC_SORTER_FN = function (value1, value2) {
    return String(value1).localeCompare(String(value2));
};
/**
 * @stable [07.03.2019]
 * @param {number} value1
 * @param {number} value2
 * @returns {number}
 * @constructor
 */
exports.ID_DESC_SORTER_FN = function (value1, value2) {
    return value1 === value2 ? 0 : (value1 > value2 ? -1 : 1);
};
/**
 * @stable [08.03.2019]
 * @param {StringNumberT} value1
 * @param {StringNumberT} value2
 * @returns {number}
 * @constructor
 */
exports.ID_ASC_SORTER_FN = function (value1, value2) {
    return exports.ID_DESC_SORTER_FN(value1, value2) * -1;
};
/**
 * @stable [29.08.2018]
 * @param {TEntity} item1
 * @param {TEntity} item2
 * @returns {number}
 * @constructor
 */
exports.ID_ASC_ENTITIES_SORTER_FN = function (item1, item2) {
    return exports.ID_ASC_SORTER_FN(item1.id, item2.id);
};
/**
 * @stable [13.05.2019]
 * @param {TEntity} item1
 * @param {TEntity} item2
 * @returns {number}
 * @constructor
 */
exports.ID_DESC_ENTITIES_SORTER_FN = function (item1, item2) {
    return exports.ID_DESC_SORTER_FN(item1.id, item2.id);
};
/**
 * @stable [29.08.2018]
 * @param {TEntity} item1
 * @param {TEntity} item2
 * @returns {number}
 */
exports.$DATE_DESC_ENTITIES_SORTER_FN = function (item1, item2) {
    return item1.$date > item2.$date ? -1 : 1;
};
//# sourceMappingURL=sort.js.map